// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
 *
 * Atmel Corporation
 *
 * - ̧			: main.c
 * - ߲			: IAR EWAVR 4.11A
 *
 * - xҰ		: avr@atmel.com
 *
 * - x޲		: ̗ATtiny24pɏĂ܂B
 *
 * - pLq		: AVR245: LCDt
 * - ֘ApLq	: AVR155ɊĂ܂B
 *
 * - 			: 4~4s^߯ޗpײ
 *
 * $Revision: 1.3 $
 * $Date: Monday, October 10, 2005 13:23:34 UTC $
 *
 *****************************************************************************/

#include "KPD.h"

unsigned char KPD_KeyPressed;
unsigned char KPD_LastKey;
unsigned char KPD_ScanRow;
unsigned char KPD_KeyDown;

__flash static unsigned char KPD_Array[4][4] = { {'1','4','7','A'},		// 蓖ĕ\
												 {'2','5','8','0'},
												 {'3','6','9','B'},
												 {'F','E','D','C'}};

void  KPD_Init(void)
{
  TCCR0B = 0;						// /0~

  KPD_KeyPressed = 0;				// ׸ޏ
  KPD_LastKey = 0;					// 
  KPD_ScanRow = 0;					// v평
  KPD_KeyDown = 0;					// ON׸ޏ

  DDRA |= (1 << PINA0);				// 1([)ݏo͐ݒ
  DDRA |= (1 << PINA1);				// 2ݏo͐ݒ
  DDRA |= (1 << PINA2);				// 3ݏo͐ݒ
  DDRA |= (1 << PINA3);				// 4(E[)ݏo͐ݒ
  PORTA |= (1 << PINA0);			// 1([)Higho͐ݒ
  PORTA |= (1 << PINA1);			// 2Higho͐ݒ
  PORTA |= (1 << PINA2);			// 3Higho͐ݒ
  PORTA |= (1 << PINA3);			// 4(E[)Higho͐ݒ

  DDRB &= ~(1 << PINB0);			// s1([)ݓ͐ݒ
  DDRB &= ~(1 << PINB1);			// s2ݓ͐ݒ
  DDRB &= ~(1 << PINB2);			// s3ݓ͐ݒ
  PORTB |= (1 << PINB0);			// s1([) ٱߋ
  PORTB |= (1 << PINB1);			// s2 ٱߋ
  PORTB |= (1 << PINB2);			// s3 ٱߋ

#ifdef DEBUGWIRE
#else
  DDRB &= ~(1 << PINB3);			// s4([)ݓ͐ݒ
  PORTB |= (1 << PINB3);			// s4([) ٱߋ
#endif

  PCMSK1 |= (1 << PCINT8);			// s1(PB0)ݕω荞݋
  PCMSK1 |= (1 << PCINT9);			// s2(PB1)ݕω荞݋
  PCMSK1 |= (1 << PCINT10);			// s3(PB2)ݕω荞݋

#ifdef DEBUGWIRE
#else
  PCMSK1 |= (1 << PCINT11);			// s4(PB3)ݕω荞݋
#endif

  GIMSK |= (1 << PCIE1);			// ݕω1Q荞݋
  GIFR |= (1 << PCIF1);				// ݕω1Q荞ݗv׸މ(0)

  TCNT0 = 0;						// /0l
  TIMSK0 = (1 << TOIE0);			// /0ꊄ荞݋
  TCCR0A = 0;						// T/C0Ww
  TCCR0B = (1<<CS01)|(1<<CS00);		// 8OuT/C0n(2ms/1MHz)

  asm("sei");						// S̊荞݋
}

unsigned char KPD_GetKey(void)
{
  if (KPD_KeyPressed)				// LŁA
  {
	KPD_KeyPressed = 0;				// ׸މ
	return (KPD_LastKey);			// ƋɕA
  }
  else								// ȂŁA
	return (0);						// ȂƋɕA
}

// SREGI=1GIMSKPCIE1=1̎Ɏs܂BGIFRPCIF1͂̎s̓ŉ܂B
#pragma vector = PCINT1_vect
__interrupt void PCINT1_ISR(void)
{
  unsigned int delay=2857;			// 7CPU/1v20ms/1MHz(:߲׈ˑ)
  unsigned char column;				// _Ή擾l

  GIMSK &= ~(1 << PCIE1);			// ݕω1Q荞݈ꎞ֎~(ݸޏ̂)
  do
  {}
  while(delay--);					// 莞ԑҋ@(ݸޏ)
  GIMSK |= (1 << PCIE1);			// ݕω1Q荞ݍċ

#ifdef DEBUGWIRE
  column = (~PINB) & 0x07;			// Ήl𐳘_Ŏ擾
#else
  column = (~PINB) & 0x0F;			// Ήl𐳘_Ŏ擾
#endif

  switch (column)					// Ή񏈗
  {
	case  0x00: KPD_KeyDown = 0;							// ȂŁAON׸މ
				break;
	case  0x01: KPD_LastKey = KPD_Array[KPD_ScanRow][0];	// s1([)ŁAΉ擾/ݒ
				if (!KPD_KeyDown)		// OSOFFŁA
				  KPD_KeyPressed = 1;	// ׸ސݒ(ON̏łݒ)
				KPD_KeyDown = 1;		// ON׸ސݒ(ON͐ݒԌp)
				break;
	case  0x02: KPD_LastKey = KPD_Array[KPD_ScanRow][1];	// s2ŁAΉ擾/ݒ
				if (!KPD_KeyDown)		// OSOFFŁA
				  KPD_KeyPressed = 1;	// ׸ސݒ
				KPD_KeyDown = 1;		// ON׸ސݒ(ON͐ݒԌp)
				break;
	case  0x04: KPD_LastKey = KPD_Array[KPD_ScanRow][2];	// s3ŁAΉ擾/ݒ
				if (!KPD_KeyDown)		// OSOFFŁA
				  KPD_KeyPressed = 1;	// ׸ސݒ
				KPD_KeyDown = 1;		// ON׸ސݒ(ON͐ݒԌp)
				break;
	case  0x08: KPD_LastKey = KPD_Array[KPD_ScanRow][3];	// s4([)ŁAΉ擾/ݒ
				if (!KPD_KeyDown)		// OSOFFŁA
				  KPD_KeyPressed = 1;	// ׸ސݒ
				KPD_KeyDown = 1;		// ON׸ސݒ(ON͐ݒԌp)
				break;
	default:    KPD_LastKey = 0;							// 
				KPD_KeyPressed = 0;							// ׸މ
  }
}

#pragma vector = TIM0_OVF_vect
__interrupt void TC0_ISR(void)
{
  if (!KPD_KeyDown)					// SOFFŁA
  {
    PORTA |= (1 << KPD_ScanRow);	// ݏo͂HighɕA
    if (++KPD_ScanRow > 3)			// vis,ŏIzŁA
      KPD_ScanRow = 0;				// 擪ɕύX
    PORTA &= ~(1 << KPD_ScanRow);	// Lowo͐ݒ
  }
}
