// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
 *
 * Atmel Corporation
 *
 * - ̧			: main.c
 * - ߲			: IAR EWAVR 4.11A
 *
 * - xҰ		: avr@atmel.com
 *
 * - x޲		: ̗ATtiny24pɏĂ܂B
 *
 * - pLq		: AVR245: LCDt
 * - ֘ApLq	: AVR155ɊĂ܂B
 *
 * - 			: ꂽPhilips PCF2119RUgpBatron BTHQ 21605AV
 *					  p LCDײ
 *
 * $Revision: 1.3 $
 * $Date: Monday, October 10, 2005 13:23:34 UTC $
 *
 *****************************************************************************/

#include "LCD.h"
#include "USI_TWI_Master.h"

extern unsigned char messageBuf[];

unsigned char LCD_Init(void)
{

  messageBuf[0] = LCD_ADR | (FALSE<<TWI_READ_BIT);	// ]uڽ+R/W(W)
  messageBuf[1] = 0x00;								// ޲
  messageBuf[2] = 0x34;								// : 162s
  messageBuf[3] = 0x0C;								// : \ON,OFF
  messageBuf[4] = 0x06;								// : is,ĂȂ
  messageBuf[5] = 0x35;								// : g߂ֈڍs
  messageBuf[6] = 0x04;								// : ˉE,ˉ
  messageBuf[7] = 0x10;								// : TC1=0,TC2=0
  messageBuf[8] = 0x42;								// : HViK3
  messageBuf[9] = 0x9F;								// : VLCDݒ,VAi[
  messageBuf[10] = 0x34;							// : W߂֕A
  messageBuf[11] = 0x80;							// : DDRAMڽ=0x00
  messageBuf[12] = 0x02;							// : ٌ_ʒuA

  return (USI_TWI_Start_Transceiver_With_Data(messageBuf,13));	// ԒlƋɕA
}

//	* ʏ *
unsigned char LCD_ClearDisplay(void)
{
  unsigned char statusTWI;

  statusTWI = LCD_ClearLine(0);						// 1sڏ
  if (statusTWI)									// ŁA
	return (LCD_ClearLine(1));						// 2sڏ,ԒlƋɕA
  else												// sŁA
	return (statusTWI);								// ԒlƋɕA
}

//	* s *
unsigned char LCD_ClearLine(unsigned char row)
{
  unsigned char i=0, statusTWI;

  do
    statusTWI = LCD_PutXY_Raw(0xA0,i%16,row);		// Ήʒu̕󔒕\
  while ((i++ < 16) & statusTWI);					// s[܂Ōp
  return (statusTWI);								// ԒlƋɕA
}

//	* ws/֕ *
unsigned char LCD_PutXY(unsigned char ch, unsigned char column, unsigned char row)
{
  return (LCD_PutXY_Raw(ASCIItoLCD(ch),column,row));
}

//	* ws/֕ *
unsigned char LCD_PutXY_Raw(unsigned char ch, unsigned char column, unsigned char row)
{
  unsigned char statusTWI;

  messageBuf[0] = LCD_ADR | (FALSE<<TWI_READ_BIT);	// ]uڽ+R/W(W)
  messageBuf[1] = 0x00;								// ޲(DDRAMʒuw)
  if (row == 0)										// 1sڂȂA
    messageBuf[2] = 0x80 + column;					// DDRAMڽ+$00+sʒu
  else												// 2sڂȂA
    messageBuf[2] = 0xC0 + column;					// DDRAMڽ+$10+sʒu
  statusTWI = USI_TWI_Start_Transceiver_With_Data(messageBuf,3);	// DDRAMʒuw
  if (!statusTWI)									// sŁA
    return (statusTWI);								// ԒlƋɕA

  messageBuf[0] = LCD_ADR | (FALSE<<TWI_READ_BIT);	// ]uڽ+R/W(W)
  messageBuf[1] = 0x40;								// ޲(DDRAMް)
  messageBuf[2] = ch;								// 
  return (USI_TWI_Start_Transceiver_With_Data(messageBuf,3));		// DDRAM
}

//	* 1s(16) *
unsigned char LCD_WriteLine(unsigned char *msg, unsigned char row)
{
  unsigned char i, statusTWI;

  messageBuf[0] = LCD_ADR | (FALSE<<TWI_READ_BIT);	// ]uڽ+R/W(W)
  messageBuf[1] = 0x00;								// ޲(DDRAMʒuw)
  if (row == 0)										// 1sڂȂA
    messageBuf[2] = 0x80;							// DDRAMڽ1sڐ擪Ɏw
  else												// 2sڂȂA
    messageBuf[2] = 0xC0;							// DDRAMڽ2sڐ擪Ɏw
  statusTWI = USI_TWI_Start_Transceiver_With_Data(messageBuf,3);	// DDRAMʒuw
  if (!statusTWI)									// sŁA
    return (statusTWI);								// ԒlƋɕA

  messageBuf[0] = LCD_ADR | (FALSE<<TWI_READ_BIT);	// ]uڽ+R/W(W)
  messageBuf[1] = 0x40;								// ޲(DDRAMް)
  for (i=0;i<16;i++)								// 16̕ޯ̧Ɋi[
    messageBuf[2+i] = ASCIItoLCD(*(msg++));
  return (USI_TWI_Start_Transceiver_With_Data(messageBuf,18));	// DDRAM,ԒlƋɕA
}

//	* ASCIILCDϊ *
unsigned char ASCIItoLCD(unsigned char ch)
{
  unsigned char c;

  c = 0x40;								// 󔒕ݒ
  if ((ch >= 0x20) & (ch <= 0x3F))		// LCDŗLȐƋLŁA
    c = 0x80 + ch;						// LCD֕ϊ
  if ((ch >= 0x41) & (ch <= 0x5A))		// LCDŗLȑ啶̧ޯĂŁA
    c = 0x80 + ch;						// LCD֕ϊ
  if ((ch >= 0x61) & (ch <= 0x7A))		// LCDŗLȏ̧ޯĂŁA
    c = 0x80 + ch;						// LCD֕ϊ
  return c;								// ϊ̕ƋɕA
}
